// Char8ArrayMessage.h
/*************************************************************************
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory, and the Regents of the University of California, as
* Operator of Los Alamos National Laboratory. MPF is distributed
* subject to a Software License Agreement found in file LICENSE that
* is included with this distribution.
*************************************************************************/

#ifndef Char8ArrayMessageH
#define Char8ArrayMessageH

#include "Message.h"
#include "StandardFieldsMessage.h"
class DLList;

class Char8ArrayMessage : public StandardFieldsMessage
{
public:
    Char8ArrayMessage();
    virtual ~Char8ArrayMessage() {freeValue();}
    virtual int32  toBuffer(char **buffer) const;
    virtual int32  fromBuffer(const char **buffer);
    virtual int32  fromBufferSwitch(const char **buffer);
    virtual void print() const;
    static void *operator new(size_t size);
    void operator delete(void *p, size_t size);
    //Char8ArrayMessage specific methods
    void setSize(int32 size);
    int32 getSize() { return(size); }
    int32 getMaxSize() { return(maxSize); };
    void allocValue(int32 maxSize);
    void freeValue();
    //following are for use by client/server
    char8 *value;
    int16 numberRetrys;
    int16 eomLen;
    char8 eomString[2];
protected:
    Char8ArrayMessage(messageType type);
private:
    static DLList *pFreeList;
    int32 maxSize;
    int32 size;
    // Disallow copy constructor, assignment operator 
    Char8ArrayMessage(const Char8ArrayMessage&);
    Char8ArrayMessage& operator=(const Char8ArrayMessage&);
};

#endif /*Char8ArrayMessageH*/
