// RebootvxWorks.cpp

/* Author:  Marty Kraimer Date:    APR99 */

/*************************************************************************
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory, and the Regents of the University of California, as
* Operator of Los Alamos National Laboratory. MPF is distributed
* subject to a Software License Agreement found in file LICENSE that
* is included with this distribution.
*************************************************************************/
#include <vxWorks.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <stdio.h>
#include <taskLib.h>
#include <rebootLib.h>

#include "Reboot.h"
#include "DLList.h"

static DLList *pDLList = 0;

static void pvtCallback();

class RebootNode
{
public:
    rebootCallback callback;
    void *userPvt;
};


void Reboot:: rebootHookAdd(rebootCallback callback,void *userPvt)
{
    if(pDLList==0) {
        pDLList = new DLList;
        ::rebootHookAdd((FUNCPTR)pvtCallback);
    }
    RebootNode *pRebootNode = new RebootNode;
    pRebootNode->callback = callback;
    pRebootNode->userPvt = userPvt;
    DLNode *node = DLList::allocNode();
    node->obj = (void *)pRebootNode;
    pDLList->addEnd(node);
}
        
static void pvtCallback()
{
    DLNode *node = pDLList->getFirst();
    while(node) {
        RebootNode *pRebootNode = (RebootNode *)node->obj;
        (*pRebootNode->callback)(pRebootNode->userPvt);
        node = pDLList->getNext(node);
    }
}
        
